<?php include('includes/database.php'); 
ini_set('memory_limit', '96M');
?>
<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Create active prompt</title>
  <script type="text/javascript" src="resources/jquery/jquery.js"></script>
  <script type="text/javascript" src="resources/jquery/jquery.ui.all.js"></script>
  <script type="text/javascript" src="resources/js/prompt.js"></script>
  <link type="text/css" rel="stylesheet" media="all" href="resources/style.css" />
</head>
<body>
  <!-- This file is responsible for taking initial user input and creating a prompt from it -->
  <div id="wrapper">
    
    <?php
    
    if (!isset($_FILES['file'])) {
      
      print '<div id="inner-wrapper">';
      print '<p>Upload a new prompt using the form below, or visit the <a href="gallery.php">gallery of prompts</a> to get some ideas.</p>';
      print '<form action="index.php" method="post" enctype="multipart/form-data">';
      print '  <label for="file">Select image (max 2MB)<sup>*</sup>:</label>';
      print '  <input type="file" name="file" id="file"><br>';
      print '  <label for="prompt">Enter prompt:</label>';
      print '  <input type="input" name="prompt" value="" /><br />';
      print '  <input type="submit" name="submit" value="Submit">';
      print '</form>';
      print '<div id="warning"><sup>*</sup>Doesn\'t work with transparent images yet, not sure why.</div>';
      print '</div>';
      
    } else {
      
      print '<div id="page-wrapper">';
      print '<p>Upload a <a href="index.php">new prompt</a><sup>*</sup> or visit the <a href="gallery.php">gallery of prompts</a> to get some ideas.</p>';
      
      // validate the file
      $allowedExts = array("jpg", "jpeg", "gif", "png");
      $extension = end(explode(".", $_FILES["file"]["name"]));
      
      // first check the file type & extension
      if ((($_FILES["file"]["type"] == "image/gif") || ($_FILES["file"]["type"] == "image/jpeg") || ($_FILES["file"]["type"] == "image/png") || ($_FILES["file"]["type"] == "image/pjpeg")) && in_array($extension, $allowedExts)) {
      
        //print 'File size:' . $_FILES["file"]["size"] . '<br />';
        
        // now check the file size is okay and that the temporary file exists
        // max file size = 2MB
        
        if ($_FILES["file"]["size"] < 2097152 && isset($_FILES['file']['tmp_name'])) {
          
          // now move the file from the temporary directory to the data directory
          
          // first create the subdirectory folder names, if necessary
          // year
          $subfolder1 = date("Y");

          // month
          $subfolder2 = date("n");

          // day
          $subfolder3 = date("j");

          // set up the directory structure for saving the images
          if (!is_dir('images/' . $subfolder1)) {
            mkdir('images/' . $subfolder1);
          }

          if (!is_dir('images/' . $subfolder1 . '/' . $subfolder2)) {
            mkdir('images/' . $subfolder1 . '/' . $subfolder2);
          }
          
          if (!is_dir('images/' . $subfolder1 . '/' . $subfolder2 . '/' . $subfolder3)) {
            mkdir('images/' . $subfolder1 . '/' . $subfolder2 . '/' . $subfolder3);
          }
          
          $newname = md5($_FILES['file']['name'] . time());
          
          // create the new file name
          $filename = 'images/' . $subfolder1 . '/' . $subfolder2 . '/' . $subfolder3 . '/' . $newname . '.' . $extension;
          
          // This is the temporary file created by PHP
          $uploadedfile = $_FILES['file']['tmp_name'];
          
          // make a local copy of this file in our tmp directory
          //$tmpname = 'tmp/' . $newname . '.' . $extension;
          //rename($_FILES['file']['tmp_name'], $tmpname);
 
          // Create an Image from it so we can do the resize
          // need to be able to accept png jpg and gifs
          if ($extension == 'jpeg' || $extension == 'jpg') {
            $src = imagecreatefromjpeg($uploadedfile);
          }
          
          if ($extension == 'gif') {
            $src = imagecreatefromgif($uploadedfile);
          }
          
          if ($extension == 'png') {
            $src = imagecreatefrompng($uploadedfile);
          }
 
          // Capture the original size of the uploaded image
          list($width, $height) = getimagesize($uploadedfile);
 
          // For our purposes, I have resized the image to be
          // 600 pixels wide, and maintain the original aspect
          // ratio. This prevents the image from being "stretched"
          // or "squashed". If you prefer some max width other than
          // 600, simply change the $newwidth variable
          $newwidth = 600;
          $newheight = ($height/$width)*600;
          $tmp = imagecreatetruecolor($newwidth, $newheight);
          
          switch ($extension) {
            case "png":
              // integer representation of the color black (rgb: 0,0,0)
              //$background = imagecolorallocate($tmp, 255, 255, 255);
              // removing the black from the placeholder
              //imagecolortransparent($tmp, $background);

              // turning off alpha blending (to ensure alpha channel information 
              // is preserved, rather than removed (blending with the rest of the 
              // image in the form of black))
              imagealphablending($tmp, false);

              // turning on alpha channel information saving (to ensure the full range 
              // of transparency is preserved)
              imagesavealpha($tmp, true);

              break;
            case "gif":
              // integer representation of the color black (rgb: 0,0,0)
              $background = imagecolorallocate($tmp, 255, 255, 255);
              // removing the black from the placeholder
              imagecolortransparent($tmp, $background);

              break;
          }
 
          // this line actually does the image resizing, copying from the original
          // image into the $tmp image
          imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
          

          //imagecopyresized($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
          
          //imagecopyresampled ( resource $dst_image , resource $src_image , int $dst_x , int $dst_y , int $src_x , int $src_y , int $dst_w , int $dst_h , int $src_w , int $src_h )
          //imagecopyresized ( resource $dst_image , resource $src_image , int $dst_x , int $dst_y , int $src_x , int $src_y , int $dst_w , int $dst_h , int $src_w , int $src_h )
 
          // now write the resized image to disk.
          imagejpeg($tmp, $filename, 100);
          //imagejpeg($src, $filename, 100);
          
          // next create a thumbnail
          $newwidth = 120;
          $newheight = ($height/$width)*120;
          $tmp = imagecreatetruecolor($newwidth, $newheight);
         
          $thumbnail = 'images/' . $subfolder1 . '/' . $subfolder2 . '/' . $subfolder3 . '/' . $newname . '-thumbnail.' . $extension;
          
          switch ($extension) {
            case "png":
              // integer representation of the color black (rgb: 0,0,0)
              //$background = imagecolorallocate($tmp, 255, 255, 255);
              // removing the black from the placeholder
              //imagecolortransparent($tmp, $background);

              // turning off alpha blending (to ensure alpha channel information 
              // is preserved, rather than removed (blending with the rest of the 
              // image in the form of black))
              imagealphablending($tmp, false);

              // turning on alpha channel information saving (to ensure the full range 
              // of transparency is preserved)
              imagesavealpha($tmp, true);

              break;
            case "gif":
              // integer representation of the color black (rgb: 0,0,0)
              $background = imagecolorallocate($tmp, 255, 255, 255);
              // removing the black from the placeholder
              imagecolortransparent($tmp, $background);

              break;
          }
          
          // resize to the thumbnail
          imagecopyresampled($tmp, $src, 0, 0, 0, 0, $newwidth, $newheight, $width, $height);
          

          
          
          // save the thumbnail
          imagejpeg($tmp, $thumbnail, 100);
 
          imagedestroy($src);
          imagedestroy($tmp); // NOTE: PHP will clean up the temp file it created when the request
                              // has completed.
          // delete the temporary file
          // file_delete($tmpname);
          
          // open up the image and resize it
          
          
          // now create the unique links to the poll
          $poll = false;
          while (!$poll) {
            $poll = random_string();
            
            $result = db_fetch_array(db_query("SELECT * FROM prompts WHERE poll = '" . $poll . "';"));
            
            if (count($result) > 0) {
              $poll = false;
            }
          }
          
          // create a unique link to the response
          $response = false;
          while (!$response) {
            $response = random_string();
            
            $result = db_fetch_array(db_query("SELECT * FROM prompts WHERE responses = '" . $response . "';"));
            
            if (count($result) > 0) {
              $response = false;
            }
          }
          

          print '<img src="' . $filename . '" /><br />';
          
          $prompt = '';
          if (isset($_POST['prompt'])) {
            // need to validate this carefully!
            $prompt = $_POST['prompt'];
            
            // convert html special characters
            $prompt = htmlspecialchars($prompt);
            
            // allowed characters
            $chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ,!?-()$^%#@/:; .";
            
            // regular expression pattern
            $pattern = "/[^".preg_quote($chars, "/")."]/";
            
            // now strip all of the not allowed characters
            $prompt = preg_replace($pattern, "", $prompt);
          }
          
          // now store this information in the database
          db_query("INSERT INTO prompts (image, thumbnail, poll, responses, prompt, timestamp) VALUES('" . $filename . "', '" . $thumbnail . "', '" . $poll . "', '" . $response . "','" . $prompt . "'," . time() . ");");
          
          // mirror back the response
          print '<div id="prompt">' . $prompt . '</div>';
          
          // now display this information for the user
          print '<div class="links">The link to the poll is <a href="poll.php?q=' . $poll . '">' . $ACTIVEPROMPT_BASEURL . '/' . $_SERVER['PHP_SELF'] . '/poll.php?q=' . $poll . '</a><br />';
          print 'The link to the responses is <a href="view.php?q=' . $response . '">' . $ACTIVEPROMPT_BASEURL . '/' . $_SERVER['PHP_SELF'] . '/view.php?q=' . $response . '</a></div>';

        // file too large 
        } else {
          print 'File too large. Please try resizing the image and <a href="index.php">uploading it again.</a>'; 
        }
      
      // wrong type of image
      } else {
        print 'This is not a JPEG, GIF, or PNG. Please try <a href="index.php">uploading it again.</a>';
      }
      print '</div>';
    }
    
    ?>
  
  </div>

</body>
</html>